import { Box, Button, Card, DialogActions, DialogContent, DialogTitle, FormControlLabel, Grid2, Radio, RadioGroup, Step, StepLabel, Stepper, Typography } from "@mui/material";
import { cloneDeep } from "lodash";
import { getSubtypes, Subtype } from "pbHelpers/ComponentType";
import { pond, quack } from "protobuf-ts/pond";
import React from "react";
import { useEffect, useState } from "react";
import ScannedI2C from "./ScannedI2C";
import ComponentForm from "component/ComponentForm";
import { Component, Device } from "models";
import { DeviceAvailabilityMap, OffsetAvailabilityMap } from "pbHelpers/DeviceAvailability";
import ResponsiveDialog from "common/ResponsiveDialog";
import { useComponentAPI, useDeviceAPI, useSnackbar } from "hooks";

interface Props {
  scannedComponents: pond.ComponentAddressMap
  device: Device
  availablePositions: DeviceAvailabilityMap
  availableOffsets: OffsetAvailabilityMap
  refreshCallback: () => void
}
 
interface CompStep {
  label: string;
  completed?: boolean;
}

let i2cBlacklistAddresses: number[] = [0x70]

export default function DeviceScannedComponents(props: Props){
  const {scannedComponents, device, availablePositions, availableOffsets, refreshCallback} = props
  const compAPI = useComponentAPI();
  const deviceAPI = useDeviceAPI()
  const [scannedI2C, setScannedI2C] = useState<pond.DetectI2C>() //the unmodified scan of addresses
  const [validCompAddresses, setValidComponentAddresses] = useState<quack.AddressData[]>([]) //the filtered array of address data
  const [components, setComponents] = useState<Component[]>([])
  const [steps, setSteps] = useState<CompStep[]>([]);
  const { error, success } = useSnackbar();
  const [currentStep, setCurrentStep] = useState(0)
  const [settingsValid, setSettingsValid] = useState(false);
  const [openDialog, setOpenDialog] = useState(false);

  useEffect(()=>{
    if (scannedComponents.i2c) setScannedI2C(scannedComponents.i2c)
    //makes the array empty for testing
    // if (scannedComponents.i2c) {
    //   let clone = cloneDeep(scannedComponents.i2c)
    //   if (clone.settings){
    //     clone.settings.foundAddresses = []
    //   }
    //   setScannedI2C(clone)
    // }
  },[scannedComponents])

  useEffect(() => {
    let steps: CompStep[] = []
    components.forEach(comp => {
      steps.push({
        label: comp.name(),
        completed: false
      })
    })
    setSteps(steps)
  },[components])

  useEffect(()=>{
    let valid: quack.AddressData[] = []
    //filter the address data
    scannedI2C?.settings?.foundAddresses.forEach(addrData => {
      if(!i2cBlacklistAddresses.includes(addrData.address)){
        if(!(addrData.address === 0x71 && addrData.expansionLine === undefined)){
          valid.push(addrData)
        }
      }
    })
    setValidComponentAddresses(valid)
  },[scannedI2C])

  const stepper = () => {
    return (
      <Stepper nonLinear activeStep={currentStep} style={{ width: "100%" }}>
        {steps.map(compStep => {
          const labelProps: {
            optional?: React.ReactNode;
          } = {};
          return (
            <Step key={compStep.label} completed={compStep.completed}>
              <StepLabel {...labelProps}>{compStep.label}</StepLabel>
            </Step>
          );
        })}
      </Stepper>
    );
  };

  const addComponents = () => {
    let c: pond.MultiComponentSettings = pond.MultiComponentSettings.create();
    components.forEach(component => {
      c.components.push(component.settings);
    });
    compAPI
      .addMultiComponents(device.id(), c)
      .then(resp => {
        success("Components added to Device");
      })
      .catch(err => {
        error("One or more component failed to add");
      })
      .finally(() => {
        refreshCallback();
      });
  };

  const addComponentDialog = () => {
    return (
      <ResponsiveDialog open={openDialog} onClose={()=>{setOpenDialog(false)}}>
        <DialogTitle>Adding Components</DialogTitle>
        <DialogContent>
          {stepper()}
          <ComponentForm
            component={components[currentStep]}
            canEdit
            device={device}
            componentChanged={(component, isValid) => {
              components[currentStep].settings = component.settings;
              setSettingsValid(isValid);
            }}
            />
        </DialogContent>
          <DialogActions>
            <Grid2 container direction="row" justifyContent="space-between">
              <Grid2>
                <Button
                  variant="contained"
                  color="primary"
                  onClick={() => {
                    setOpenDialog(false)
                  }}>
                  Cancel
                </Button>
              </Grid2>
              <Grid2>
                {currentStep !== 0 && (
                  <Button
                    sx={{marginX: 1}}
                    variant="contained"
                    color="primary"
                    onClick={() => {
                      setCurrentStep(currentStep - 1);
                    }}>
                    Back
                  </Button>
                )}
                {currentStep !== steps.length - 1 && (
                  <React.Fragment>
                    <Button
                    sx={{marginX: 1}}
                      variant="contained"
                      color="primary"
                      onClick={() => {
                        setCurrentStep(currentStep + 1);
                      }}>
                      Next
                    </Button>
                  </React.Fragment>
                )}
                <Button
                  sx={{marginX: 1}}
                  variant="contained"
                  color="primary"
                  onClick={() => {
                    setOpenDialog(false)
                    addComponents();
                  }}>
                  Confirm
                </Button>
              </Grid2>
            </Grid2>
          </DialogActions>
      </ResponsiveDialog>
    );
  };

  const componentSelection = (newComponents: Component[], checked: boolean) => {
    let cloneList = cloneDeep(components)
    if(checked){
      //add the component to the list
      cloneList = cloneList.concat(newComponents)
    }else{
      newComponents.forEach(newComponent => {
        //remove any components that match the component location: (type)-(addressType)-(address)
        cloneList.forEach((comp, i) => {
          //check the components location against the one in the list
          if(comp.locationString() === newComponent.locationString()){
            cloneList.splice(i, 1)
          }
        })
      })
    }
    setComponents(cloneList)
  }

  const removeScan = (key: string) => {
    deviceAPI.removeFoundComponents(device.settings.deviceId, key)
    .then(resp => {
      console.log("Cleared this scan")
    }).catch(err => {
      console.log("There was a problem clearing this scan")
    })
  }



  return (
    <React.Fragment>
      <Card raised sx={{padding: 1}}>
        {scannedI2C !== undefined && 
          <React.Fragment>
          <Box justifyContent="space-between" display="flex">
            <Typography sx={{fontWeight: 650}}>
              I2C Sensors
            </Typography>
            <Button variant="contained" color="primary" onClick={()=>{removeScan(scannedI2C.key)}}>Clear Scan</Button>
          </Box>
          {validCompAddresses.length > 0 ? validCompAddresses.map((addr, index) => {
            return (
              <ScannedI2C key={index} sensorNum={index+1} addressData={addr} deviceProduct={device.settings.product} componentSelectionCallback={componentSelection} availablePositions={availablePositions.get(quack.AddressType.ADDRESS_TYPE_I2C) ?? []}/>
            )
          }) :
            <Box sx={{
              margin: 1,
              display: "flex",
              justifyContent: "center"
            }}>
              <Typography>
                No Sensors Found  
              </Typography>
            </Box>
          }
          </React.Fragment>
        }
        <Box display="flex" flexDirection="row-reverse" marginTop={2}>
          <Button disabled={components.length === 0} variant="contained" color="primary" onClick={()=>{setOpenDialog(true)}}>Add Components</Button>
        </Box>
      </Card>
      {addComponentDialog()}
    </React.Fragment>
  )
}